'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var utilsHooks = require('@highlight-ui/utils-hooks');
var utilsCommons = require('@highlight-ui/utils-commons');
var classnames = require('classnames');
var typography = require('@highlight-ui/typography');
var icon = require('@highlight-ui/icon');
var checkbox = require('@highlight-ui/checkbox');
var avatar = require('@highlight-ui/avatar');
var button = require('@highlight-ui/button');
var colorPicker = require('@highlight-ui/color-picker');
var input = require('@highlight-ui/input');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
function __rest(s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}
function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}
function getSelectedValues(_a) {
  var multiple = _a.multiple,
    option = _a.option,
    selectedOptions = _a.selectedOptions,
    selectedOptionsWithValuesOnly = _a.selectedOptionsWithValuesOnly;
  if (!multiple) {
    return [option];
  }
  if (selectedOptionsWithValuesOnly.includes(option.value)) {
    return selectedOptions.filter(function (selectedOption) {
      return selectedOption.value !== option.value;
    });
  }
  return __spreadArray(__spreadArray([], selectedOptions, true), [option], false);
}
/**
 * Returns options that are pre-selected and disabled.
 * @param allOptions
 * @param preSelectedOptions
 */
function getFixedOptions(allOptions, preSelectedOptions) {
  var allDisabled = allOptions.filter(function (option) {
    return option.disabled;
  });
  return allDisabled.filter(function (disabledOption) {
    return preSelectedOptions.some(function (option) {
      return option.value === disabledOption.value;
    });
  });
}
/**
 * Returns a list of option that are fixed and are enabled
 * @param options
 * @param preSelectedOptions
 */
function getAllSelectableOptions(options, preSelectedOptions) {
  var allFixed = getFixedOptions(options, preSelectedOptions);
  var allEnabled = options.filter(function (option) {
    return !option.disabled;
  });
  return __spreadArray(__spreadArray([], allFixed, true), allEnabled, true);
}
var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
  funcTag = '[object Function]',
  genTag = '[object GeneratorFunction]',
  mapTag = '[object Map]',
  objectTag = '[object Object]',
  promiseTag = '[object Promise]',
  setTag = '[object Set]',
  weakMapTag = '[object WeakMap]';
var dataViewTag = '[object DataView]';

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
    length = array ? array.length : 0,
    result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
    result = Array(n);
  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

/**
 * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array
 * of key-value pairs for `object` corresponding to the property names of `props`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array} props The property names to get values for.
 * @returns {Object} Returns the key-value pairs.
 */
function baseToPairs(object, props) {
  return arrayMap(props, function (key) {
    return [key, object[key]];
  });
}

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

/**
 * Checks if `value` is a host object in IE < 9.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
 */
function isHostObject(value) {
  // Many host objects are `Object` objects that can coerce to strings
  // despite having improperly defined `toString` methods.
  var result = false;
  if (value != null && typeof value.toString != 'function') {
    try {
      result = !!(value + '');
    } catch (e) {}
  }
  return result;
}

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
    result = Array(map.size);
  map.forEach(function (value, key) {
    result[++index] = [key, value];
  });
  return result;
}

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function (arg) {
    return func(transform(arg));
  };
}

/**
 * Converts `set` to its value-value pairs.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the value-value pairs.
 */
function setToPairs(set) {
  var index = -1,
    result = Array(set.size);
  set.forEach(function (value) {
    result[++index] = [value, value];
  });
  return result;
}

/** Used for built-in method references. */
var funcProto = Function.prototype,
  objectProto = Object.prototype;

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

/** Used to detect methods masquerading as native. */
var maskSrcKey = function () {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? 'Symbol(src)_1.' + uid : '';
}();

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' + funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView'),
  Map = getNative(root, 'Map'),
  Promise$1 = getNative(root, 'Promise'),
  Set = getNative(root, 'Set'),
  WeakMap = getNative(root, 'WeakMap');

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
  mapCtorString = toSource(Map),
  promiseCtorString = toSource(Promise$1),
  setCtorString = toSource(Set),
  weakMapCtorString = toSource(WeakMap);

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
  // Safari 9 makes `arguments.length` enumerable in strict mode.
  var result = isArray(value) || isArguments(value) ? baseTimes(value.length, String) : [];
  var length = result.length,
    skipIndexes = !!length;
  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == 'length' || isIndex(key, length)))) {
      result.push(key);
    }
  }
  return result;
}

/**
 * The base implementation of `getTag`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  return objectToString.call(value);
}

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

/**
 * Creates a `_.toPairs` or `_.toPairsIn` function.
 *
 * @private
 * @param {Function} keysFunc The function to get the keys of a given object.
 * @returns {Function} Returns the new pairs function.
 */
function createToPairs(keysFunc) {
  return function (object) {
    var tag = getTag(object);
    if (tag == mapTag) {
      return mapToArray(object);
    }
    if (tag == setTag) {
      return setToPairs(object);
    }
    return baseToPairs(object, keysFunc(object));
  };
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11,
// for data views in Edge < 14, and promises in Node.js.
if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag || Map && getTag(new Map()) != mapTag || Promise$1 && getTag(Promise$1.resolve()) != promiseTag || Set && getTag(new Set()) != setTag || WeakMap && getTag(new WeakMap()) != weakMapTag) {
  getTag = function (value) {
    var result = objectToString.call(value),
      Ctor = result == objectTag ? value.constructor : undefined,
      ctorString = Ctor ? toSource(Ctor) : undefined;
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag;
        case mapCtorString:
          return mapTag;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag;
        case weakMapCtorString:
          return weakMapTag;
      }
    }
    return result;
  };
}

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length && (typeof value == 'number' || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
}

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
    proto = typeof Ctor == 'function' && Ctor.prototype || objectProto;
  return value === proto;
}

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to process.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return func + '';
    } catch (e) {}
  }
  return '';
}

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
function isArguments(value) {
  // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
  return isArrayLikeObject(value) && hasOwnProperty.call(value, 'callee') && (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
}

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

/**
 * This method is like `_.isArrayLike` except that it also checks if `value`
 * is an object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array-like object,
 *  else `false`.
 * @example
 *
 * _.isArrayLikeObject([1, 2, 3]);
 * // => true
 *
 * _.isArrayLikeObject(document.body.children);
 * // => true
 *
 * _.isArrayLikeObject('abc');
 * // => false
 *
 * _.isArrayLikeObject(_.noop);
 * // => false
 */
function isArrayLikeObject(value) {
  return isObjectLike(value) && isArrayLike(value);
}

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 8-9 which returns 'object' for typed array and other constructors.
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag;
}

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

/**
 * Creates an array of own enumerable string keyed-value pairs for `object`
 * which can be consumed by `_.fromPairs`. If `object` is a map or set, its
 * entries are returned.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @alias entries
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the key-value pairs.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.toPairs(new Foo);
 * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)
 */
var toPairs = createToPairs(keys);
var lodash_topairs = toPairs;
var lodash_groupby = {
  exports: {}
};

/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

(function (module, exports) {
  /** Used as the size to enable large array optimizations. */
  var LARGE_ARRAY_SIZE = 200;

  /** Used as the `TypeError` message for "Functions" methods. */
  var FUNC_ERROR_TEXT = 'Expected a function';

  /** Used to stand-in for `undefined` hash values. */
  var HASH_UNDEFINED = '__lodash_hash_undefined__';

  /** Used to compose bitmasks for comparison styles. */
  var UNORDERED_COMPARE_FLAG = 1,
    PARTIAL_COMPARE_FLAG = 2;

  /** Used as references for various `Number` constants. */
  var INFINITY = 1 / 0,
    MAX_SAFE_INTEGER = 9007199254740991;

  /** `Object#toString` result references. */
  var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]',
    weakMapTag = '[object WeakMap]';
  var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

  /** Used to match property names within property paths. */
  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/,
    reLeadingDot = /^\./,
    rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

  /**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

  /** Used to match backslashes in property paths. */
  var reEscapeChar = /\\(\\)?/g;

  /** Used to detect host constructors (Safari). */
  var reIsHostCtor = /^\[object .+?Constructor\]$/;

  /** Used to detect unsigned integer values. */
  var reIsUint = /^(?:0|[1-9]\d*)$/;

  /** Used to identify `toStringTag` values of typed arrays. */
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = freeGlobal || freeSelf || Function('return this')();

  /** Detect free variable `exports`. */
  var freeExports = exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule = freeExports && 'object' == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports = freeModule && freeModule.exports === freeExports;

  /** Detect free variable `process` from Node.js. */
  var freeProcess = moduleExports && freeGlobal.process;

  /** Used to access faster Node.js helpers. */
  var nodeUtil = function () {
    try {
      return freeProcess && freeProcess.binding('util');
    } catch (e) {}
  }();

  /* Node.js helper references. */
  var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

  /**
   * A specialized version of `baseAggregator` for arrays.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} setter The function to set `accumulator` values.
   * @param {Function} iteratee The iteratee to transform keys.
   * @param {Object} accumulator The initial aggregated object.
   * @returns {Function} Returns `accumulator`.
   */
  function arrayAggregator(array, setter, iteratee, accumulator) {
    var index = -1,
      length = array ? array.length : 0;
    while (++index < length) {
      var value = array[index];
      setter(accumulator, value, iteratee(value), array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.some` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if any element passes the predicate check,
   *  else `false`.
   */
  function arraySome(array, predicate) {
    var index = -1,
      length = array ? array.length : 0;
    while (++index < length) {
      if (predicate(array[index], index, array)) {
        return true;
      }
    }
    return false;
  }

  /**
   * The base implementation of `_.property` without support for deep paths.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @returns {Function} Returns the new accessor function.
   */
  function baseProperty(key) {
    return function (object) {
      return object == null ? undefined : object[key];
    };
  }

  /**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
  function baseTimes(n, iteratee) {
    var index = -1,
      result = Array(n);
    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }

  /**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */
  function baseUnary(func) {
    return function (value) {
      return func(value);
    };
  }

  /**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */
  function getValue(object, key) {
    return object == null ? undefined : object[key];
  }

  /**
   * Checks if `value` is a host object in IE < 9.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
   */
  function isHostObject(value) {
    // Many host objects are `Object` objects that can coerce to strings
    // despite having improperly defined `toString` methods.
    var result = false;
    if (value != null && typeof value.toString != 'function') {
      try {
        result = !!(value + '');
      } catch (e) {}
    }
    return result;
  }

  /**
   * Converts `map` to its key-value pairs.
   *
   * @private
   * @param {Object} map The map to convert.
   * @returns {Array} Returns the key-value pairs.
   */
  function mapToArray(map) {
    var index = -1,
      result = Array(map.size);
    map.forEach(function (value, key) {
      result[++index] = [key, value];
    });
    return result;
  }

  /**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */
  function overArg(func, transform) {
    return function (arg) {
      return func(transform(arg));
    };
  }

  /**
   * Converts `set` to an array of its values.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the values.
   */
  function setToArray(set) {
    var index = -1,
      result = Array(set.size);
    set.forEach(function (value) {
      result[++index] = value;
    });
    return result;
  }

  /** Used for built-in method references. */
  var arrayProto = Array.prototype,
    funcProto = Function.prototype,
    objectProto = Object.prototype;

  /** Used to detect overreaching core-js shims. */
  var coreJsData = root['__core-js_shared__'];

  /** Used to detect methods masquerading as native. */
  var maskSrcKey = function () {
    var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
    return uid ? 'Symbol(src)_1.' + uid : '';
  }();

  /** Used to resolve the decompiled source of functions. */
  var funcToString = funcProto.toString;

  /** Used to check objects for own properties. */
  var hasOwnProperty = objectProto.hasOwnProperty;

  /**
   * Used to resolve the
   * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
   * of values.
   */
  var objectToString = objectProto.toString;

  /** Used to detect if a method is native. */
  var reIsNative = RegExp('^' + funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');

  /** Built-in value references. */
  var Symbol = root.Symbol,
    Uint8Array = root.Uint8Array,
    propertyIsEnumerable = objectProto.propertyIsEnumerable,
    splice = arrayProto.splice;

  /* Built-in method references for those with the same name as other `lodash` methods. */
  var nativeKeys = overArg(Object.keys, Object);

  /* Built-in method references that are verified to be native. */
  var DataView = getNative(root, 'DataView'),
    Map = getNative(root, 'Map'),
    Promise = getNative(root, 'Promise'),
    Set = getNative(root, 'Set'),
    WeakMap = getNative(root, 'WeakMap'),
    nativeCreate = getNative(Object, 'create');

  /** Used to detect maps, sets, and weakmaps. */
  var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

  /** Used to convert symbols to primitives and strings. */
  var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

  /**
   * Creates a hash object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function Hash(entries) {
    var index = -1,
      length = entries ? entries.length : 0;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }

  /**
   * Removes all key-value entries from the hash.
   *
   * @private
   * @name clear
   * @memberOf Hash
   */
  function hashClear() {
    this.__data__ = nativeCreate ? nativeCreate(null) : {};
  }

  /**
   * Removes `key` and its value from the hash.
   *
   * @private
   * @name delete
   * @memberOf Hash
   * @param {Object} hash The hash to modify.
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function hashDelete(key) {
    return this.has(key) && delete this.__data__[key];
  }

  /**
   * Gets the hash value for `key`.
   *
   * @private
   * @name get
   * @memberOf Hash
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function hashGet(key) {
    var data = this.__data__;
    if (nativeCreate) {
      var result = data[key];
      return result === HASH_UNDEFINED ? undefined : result;
    }
    return hasOwnProperty.call(data, key) ? data[key] : undefined;
  }

  /**
   * Checks if a hash value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Hash
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function hashHas(key) {
    var data = this.__data__;
    return nativeCreate ? data[key] !== undefined : hasOwnProperty.call(data, key);
  }

  /**
   * Sets the hash `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Hash
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the hash instance.
   */
  function hashSet(key, value) {
    var data = this.__data__;
    data[key] = nativeCreate && value === undefined ? HASH_UNDEFINED : value;
    return this;
  }

  // Add methods to `Hash`.
  Hash.prototype.clear = hashClear;
  Hash.prototype['delete'] = hashDelete;
  Hash.prototype.get = hashGet;
  Hash.prototype.has = hashHas;
  Hash.prototype.set = hashSet;

  /**
   * Creates an list cache object.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function ListCache(entries) {
    var index = -1,
      length = entries ? entries.length : 0;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }

  /**
   * Removes all key-value entries from the list cache.
   *
   * @private
   * @name clear
   * @memberOf ListCache
   */
  function listCacheClear() {
    this.__data__ = [];
  }

  /**
   * Removes `key` and its value from the list cache.
   *
   * @private
   * @name delete
   * @memberOf ListCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function listCacheDelete(key) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    if (index < 0) {
      return false;
    }
    var lastIndex = data.length - 1;
    if (index == lastIndex) {
      data.pop();
    } else {
      splice.call(data, index, 1);
    }
    return true;
  }

  /**
   * Gets the list cache value for `key`.
   *
   * @private
   * @name get
   * @memberOf ListCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function listCacheGet(key) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    return index < 0 ? undefined : data[index][1];
  }

  /**
   * Checks if a list cache value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf ListCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function listCacheHas(key) {
    return assocIndexOf(this.__data__, key) > -1;
  }

  /**
   * Sets the list cache `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf ListCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the list cache instance.
   */
  function listCacheSet(key, value) {
    var data = this.__data__,
      index = assocIndexOf(data, key);
    if (index < 0) {
      data.push([key, value]);
    } else {
      data[index][1] = value;
    }
    return this;
  }

  // Add methods to `ListCache`.
  ListCache.prototype.clear = listCacheClear;
  ListCache.prototype['delete'] = listCacheDelete;
  ListCache.prototype.get = listCacheGet;
  ListCache.prototype.has = listCacheHas;
  ListCache.prototype.set = listCacheSet;

  /**
   * Creates a map cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function MapCache(entries) {
    var index = -1,
      length = entries ? entries.length : 0;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }

  /**
   * Removes all key-value entries from the map.
   *
   * @private
   * @name clear
   * @memberOf MapCache
   */
  function mapCacheClear() {
    this.__data__ = {
      'hash': new Hash(),
      'map': new (Map || ListCache)(),
      'string': new Hash()
    };
  }

  /**
   * Removes `key` and its value from the map.
   *
   * @private
   * @name delete
   * @memberOf MapCache
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function mapCacheDelete(key) {
    return getMapData(this, key)['delete'](key);
  }

  /**
   * Gets the map value for `key`.
   *
   * @private
   * @name get
   * @memberOf MapCache
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function mapCacheGet(key) {
    return getMapData(this, key).get(key);
  }

  /**
   * Checks if a map value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf MapCache
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function mapCacheHas(key) {
    return getMapData(this, key).has(key);
  }

  /**
   * Sets the map `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf MapCache
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the map cache instance.
   */
  function mapCacheSet(key, value) {
    getMapData(this, key).set(key, value);
    return this;
  }

  // Add methods to `MapCache`.
  MapCache.prototype.clear = mapCacheClear;
  MapCache.prototype['delete'] = mapCacheDelete;
  MapCache.prototype.get = mapCacheGet;
  MapCache.prototype.has = mapCacheHas;
  MapCache.prototype.set = mapCacheSet;

  /**
   *
   * Creates an array cache object to store unique values.
   *
   * @private
   * @constructor
   * @param {Array} [values] The values to cache.
   */
  function SetCache(values) {
    var index = -1,
      length = values ? values.length : 0;
    this.__data__ = new MapCache();
    while (++index < length) {
      this.add(values[index]);
    }
  }

  /**
   * Adds `value` to the array cache.
   *
   * @private
   * @name add
   * @memberOf SetCache
   * @alias push
   * @param {*} value The value to cache.
   * @returns {Object} Returns the cache instance.
   */
  function setCacheAdd(value) {
    this.__data__.set(value, HASH_UNDEFINED);
    return this;
  }

  /**
   * Checks if `value` is in the array cache.
   *
   * @private
   * @name has
   * @memberOf SetCache
   * @param {*} value The value to search for.
   * @returns {number} Returns `true` if `value` is found, else `false`.
   */
  function setCacheHas(value) {
    return this.__data__.has(value);
  }

  // Add methods to `SetCache`.
  SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
  SetCache.prototype.has = setCacheHas;

  /**
   * Creates a stack cache object to store key-value pairs.
   *
   * @private
   * @constructor
   * @param {Array} [entries] The key-value pairs to cache.
   */
  function Stack(entries) {
    this.__data__ = new ListCache(entries);
  }

  /**
   * Removes all key-value entries from the stack.
   *
   * @private
   * @name clear
   * @memberOf Stack
   */
  function stackClear() {
    this.__data__ = new ListCache();
  }

  /**
   * Removes `key` and its value from the stack.
   *
   * @private
   * @name delete
   * @memberOf Stack
   * @param {string} key The key of the value to remove.
   * @returns {boolean} Returns `true` if the entry was removed, else `false`.
   */
  function stackDelete(key) {
    return this.__data__['delete'](key);
  }

  /**
   * Gets the stack value for `key`.
   *
   * @private
   * @name get
   * @memberOf Stack
   * @param {string} key The key of the value to get.
   * @returns {*} Returns the entry value.
   */
  function stackGet(key) {
    return this.__data__.get(key);
  }

  /**
   * Checks if a stack value for `key` exists.
   *
   * @private
   * @name has
   * @memberOf Stack
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function stackHas(key) {
    return this.__data__.has(key);
  }

  /**
   * Sets the stack `key` to `value`.
   *
   * @private
   * @name set
   * @memberOf Stack
   * @param {string} key The key of the value to set.
   * @param {*} value The value to set.
   * @returns {Object} Returns the stack cache instance.
   */
  function stackSet(key, value) {
    var cache = this.__data__;
    if (cache instanceof ListCache) {
      var pairs = cache.__data__;
      if (!Map || pairs.length < LARGE_ARRAY_SIZE - 1) {
        pairs.push([key, value]);
        return this;
      }
      cache = this.__data__ = new MapCache(pairs);
    }
    cache.set(key, value);
    return this;
  }

  // Add methods to `Stack`.
  Stack.prototype.clear = stackClear;
  Stack.prototype['delete'] = stackDelete;
  Stack.prototype.get = stackGet;
  Stack.prototype.has = stackHas;
  Stack.prototype.set = stackSet;

  /**
   * Creates an array of the enumerable property names of the array-like `value`.
   *
   * @private
   * @param {*} value The value to query.
   * @param {boolean} inherited Specify returning inherited property names.
   * @returns {Array} Returns the array of property names.
   */
  function arrayLikeKeys(value, inherited) {
    // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
    // Safari 9 makes `arguments.length` enumerable in strict mode.
    var result = isArray(value) || isArguments(value) ? baseTimes(value.length, String) : [];
    var length = result.length,
      skipIndexes = !!length;
    for (var key in value) {
      if ((inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == 'length' || isIndex(key, length)))) {
        result.push(key);
      }
    }
    return result;
  }

  /**
   * Gets the index at which the `key` is found in `array` of key-value pairs.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} key The key to search for.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function assocIndexOf(array, key) {
    var length = array.length;
    while (length--) {
      if (eq(array[length][0], key)) {
        return length;
      }
    }
    return -1;
  }

  /**
   * Aggregates elements of `collection` on `accumulator` with keys transformed
   * by `iteratee` and values set by `setter`.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} setter The function to set `accumulator` values.
   * @param {Function} iteratee The iteratee to transform keys.
   * @param {Object} accumulator The initial aggregated object.
   * @returns {Function} Returns `accumulator`.
   */
  function baseAggregator(collection, setter, iteratee, accumulator) {
    baseEach(collection, function (value, key, collection) {
      setter(accumulator, value, iteratee(value), collection);
    });
    return accumulator;
  }

  /**
   * The base implementation of `_.forEach` without support for iteratee shorthands.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array|Object} Returns `collection`.
   */
  var baseEach = createBaseEach(baseForOwn);

  /**
   * The base implementation of `baseForOwn` which iterates over `object`
   * properties returned by `keysFunc` and invokes `iteratee` for each property.
   * Iteratee functions may exit iteration early by explicitly returning `false`.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {Function} keysFunc The function to get the keys of `object`.
   * @returns {Object} Returns `object`.
   */
  var baseFor = createBaseFor();

  /**
   * The base implementation of `_.forOwn` without support for iteratee shorthands.
   *
   * @private
   * @param {Object} object The object to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Object} Returns `object`.
   */
  function baseForOwn(object, iteratee) {
    return object && baseFor(object, iteratee, keys);
  }

  /**
   * The base implementation of `_.get` without support for default values.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @returns {*} Returns the resolved value.
   */
  function baseGet(object, path) {
    path = isKey(path, object) ? [path] : castPath(path);
    var index = 0,
      length = path.length;
    while (object != null && index < length) {
      object = object[toKey(path[index++])];
    }
    return index && index == length ? object : undefined;
  }

  /**
   * The base implementation of `getTag`.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
  function baseGetTag(value) {
    return objectToString.call(value);
  }

  /**
   * The base implementation of `_.hasIn` without support for deep paths.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {Array|string} key The key to check.
   * @returns {boolean} Returns `true` if `key` exists, else `false`.
   */
  function baseHasIn(object, key) {
    return object != null && key in Object(object);
  }

  /**
   * The base implementation of `_.isEqual` which supports partial comparisons
   * and tracks traversed objects.
   *
   * @private
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @param {Function} [customizer] The function to customize comparisons.
   * @param {boolean} [bitmask] The bitmask of comparison flags.
   *  The bitmask may be composed of the following flags:
   *     1 - Unordered comparison
   *     2 - Partial comparison
   * @param {Object} [stack] Tracks traversed `value` and `other` objects.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   */
  function baseIsEqual(value, other, customizer, bitmask, stack) {
    if (value === other) {
      return true;
    }
    if (value == null || other == null || !isObject(value) && !isObjectLike(other)) {
      return value !== value && other !== other;
    }
    return baseIsEqualDeep(value, other, baseIsEqual, customizer, bitmask, stack);
  }

  /**
   * A specialized version of `baseIsEqual` for arrays and objects which performs
   * deep comparisons and tracks traversed objects enabling objects with circular
   * references to be compared.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Function} [customizer] The function to customize comparisons.
   * @param {number} [bitmask] The bitmask of comparison flags. See `baseIsEqual`
   *  for more details.
   * @param {Object} [stack] Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
  function baseIsEqualDeep(object, other, equalFunc, customizer, bitmask, stack) {
    var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = arrayTag,
      othTag = arrayTag;
    if (!objIsArr) {
      objTag = getTag(object);
      objTag = objTag == argsTag ? objectTag : objTag;
    }
    if (!othIsArr) {
      othTag = getTag(other);
      othTag = othTag == argsTag ? objectTag : othTag;
    }
    var objIsObj = objTag == objectTag && !isHostObject(object),
      othIsObj = othTag == objectTag && !isHostObject(other),
      isSameTag = objTag == othTag;
    if (isSameTag && !objIsObj) {
      stack || (stack = new Stack());
      return objIsArr || isTypedArray(object) ? equalArrays(object, other, equalFunc, customizer, bitmask, stack) : equalByTag(object, other, objTag, equalFunc, customizer, bitmask, stack);
    }
    if (!(bitmask & PARTIAL_COMPARE_FLAG)) {
      var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');
      if (objIsWrapped || othIsWrapped) {
        var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;
        stack || (stack = new Stack());
        return equalFunc(objUnwrapped, othUnwrapped, customizer, bitmask, stack);
      }
    }
    if (!isSameTag) {
      return false;
    }
    stack || (stack = new Stack());
    return equalObjects(object, other, equalFunc, customizer, bitmask, stack);
  }

  /**
   * The base implementation of `_.isMatch` without support for iteratee shorthands.
   *
   * @private
   * @param {Object} object The object to inspect.
   * @param {Object} source The object of property values to match.
   * @param {Array} matchData The property names, values, and compare flags to match.
   * @param {Function} [customizer] The function to customize comparisons.
   * @returns {boolean} Returns `true` if `object` is a match, else `false`.
   */
  function baseIsMatch(object, source, matchData, customizer) {
    var index = matchData.length,
      length = index,
      noCustomizer = !customizer;
    if (object == null) {
      return !length;
    }
    object = Object(object);
    while (index--) {
      var data = matchData[index];
      if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
        return false;
      }
    }
    while (++index < length) {
      data = matchData[index];
      var key = data[0],
        objValue = object[key],
        srcValue = data[1];
      if (noCustomizer && data[2]) {
        if (objValue === undefined && !(key in object)) {
          return false;
        }
      } else {
        var stack = new Stack();
        if (customizer) {
          var result = customizer(objValue, srcValue, key, object, source, stack);
        }
        if (!(result === undefined ? baseIsEqual(srcValue, objValue, customizer, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG, stack) : result)) {
          return false;
        }
      }
    }
    return true;
  }

  /**
   * The base implementation of `_.isNative` without bad shim checks.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a native function,
   *  else `false`.
   */
  function baseIsNative(value) {
    if (!isObject(value) || isMasked(value)) {
      return false;
    }
    var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
    return pattern.test(toSource(value));
  }

  /**
   * The base implementation of `_.isTypedArray` without Node.js optimizations.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   */
  function baseIsTypedArray(value) {
    return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[objectToString.call(value)];
  }

  /**
   * The base implementation of `_.iteratee`.
   *
   * @private
   * @param {*} [value=_.identity] The value to convert to an iteratee.
   * @returns {Function} Returns the iteratee.
   */
  function baseIteratee(value) {
    // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
    // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
    if (typeof value == 'function') {
      return value;
    }
    if (value == null) {
      return identity;
    }
    if (typeof value == 'object') {
      return isArray(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
    }
    return property(value);
  }

  /**
   * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   */
  function baseKeys(object) {
    if (!isPrototype(object)) {
      return nativeKeys(object);
    }
    var result = [];
    for (var key in Object(object)) {
      if (hasOwnProperty.call(object, key) && key != 'constructor') {
        result.push(key);
      }
    }
    return result;
  }

  /**
   * The base implementation of `_.matches` which doesn't clone `source`.
   *
   * @private
   * @param {Object} source The object of property values to match.
   * @returns {Function} Returns the new spec function.
   */
  function baseMatches(source) {
    var matchData = getMatchData(source);
    if (matchData.length == 1 && matchData[0][2]) {
      return matchesStrictComparable(matchData[0][0], matchData[0][1]);
    }
    return function (object) {
      return object === source || baseIsMatch(object, source, matchData);
    };
  }

  /**
   * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
   *
   * @private
   * @param {string} path The path of the property to get.
   * @param {*} srcValue The value to match.
   * @returns {Function} Returns the new spec function.
   */
  function baseMatchesProperty(path, srcValue) {
    if (isKey(path) && isStrictComparable(srcValue)) {
      return matchesStrictComparable(toKey(path), srcValue);
    }
    return function (object) {
      var objValue = get(object, path);
      return objValue === undefined && objValue === srcValue ? hasIn(object, path) : baseIsEqual(srcValue, objValue, undefined, UNORDERED_COMPARE_FLAG | PARTIAL_COMPARE_FLAG);
    };
  }

  /**
   * A specialized version of `baseProperty` which supports deep paths.
   *
   * @private
   * @param {Array|string} path The path of the property to get.
   * @returns {Function} Returns the new accessor function.
   */
  function basePropertyDeep(path) {
    return function (object) {
      return baseGet(object, path);
    };
  }

  /**
   * The base implementation of `_.toString` which doesn't convert nullish
   * values to empty strings.
   *
   * @private
   * @param {*} value The value to process.
   * @returns {string} Returns the string.
   */
  function baseToString(value) {
    // Exit early for strings to avoid a performance hit in some environments.
    if (typeof value == 'string') {
      return value;
    }
    if (isSymbol(value)) {
      return symbolToString ? symbolToString.call(value) : '';
    }
    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
  }

  /**
   * Casts `value` to a path array if it's not one.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {Array} Returns the cast property path array.
   */
  function castPath(value) {
    return isArray(value) ? value : stringToPath(value);
  }

  /**
   * Creates a function like `_.groupBy`.
   *
   * @private
   * @param {Function} setter The function to set accumulator values.
   * @param {Function} [initializer] The accumulator object initializer.
   * @returns {Function} Returns the new aggregator function.
   */
  function createAggregator(setter, initializer) {
    return function (collection, iteratee) {
      var func = isArray(collection) ? arrayAggregator : baseAggregator,
        accumulator = initializer ? initializer() : {};
      return func(collection, setter, baseIteratee(iteratee), accumulator);
    };
  }

  /**
   * Creates a `baseEach` or `baseEachRight` function.
   *
   * @private
   * @param {Function} eachFunc The function to iterate over a collection.
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */
  function createBaseEach(eachFunc, fromRight) {
    return function (collection, iteratee) {
      if (collection == null) {
        return collection;
      }
      if (!isArrayLike(collection)) {
        return eachFunc(collection, iteratee);
      }
      var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);
      while (fromRight ? index-- : ++index < length) {
        if (iteratee(iterable[index], index, iterable) === false) {
          break;
        }
      }
      return collection;
    };
  }

  /**
   * Creates a base function for methods like `_.forIn` and `_.forOwn`.
   *
   * @private
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {Function} Returns the new base function.
   */
  function createBaseFor(fromRight) {
    return function (object, iteratee, keysFunc) {
      var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;
      while (length--) {
        var key = props[fromRight ? length : ++index];
        if (iteratee(iterable[key], key, iterable) === false) {
          break;
        }
      }
      return object;
    };
  }

  /**
   * A specialized version of `baseIsEqualDeep` for arrays with support for
   * partial deep comparisons.
   *
   * @private
   * @param {Array} array The array to compare.
   * @param {Array} other The other array to compare.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Function} customizer The function to customize comparisons.
   * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
   *  for more details.
   * @param {Object} stack Tracks traversed `array` and `other` objects.
   * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
   */
  function equalArrays(array, other, equalFunc, customizer, bitmask, stack) {
    var isPartial = bitmask & PARTIAL_COMPARE_FLAG,
      arrLength = array.length,
      othLength = other.length;
    if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
      return false;
    }
    // Assume cyclic values are equal.
    var stacked = stack.get(array);
    if (stacked && stack.get(other)) {
      return stacked == other;
    }
    var index = -1,
      result = true,
      seen = bitmask & UNORDERED_COMPARE_FLAG ? new SetCache() : undefined;
    stack.set(array, other);
    stack.set(other, array);

    // Ignore non-index properties.
    while (++index < arrLength) {
      var arrValue = array[index],
        othValue = other[index];
      if (customizer) {
        var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
      }
      if (compared !== undefined) {
        if (compared) {
          continue;
        }
        result = false;
        break;
      }
      // Recursively compare arrays (susceptible to call stack limits).
      if (seen) {
        if (!arraySome(other, function (othValue, othIndex) {
          if (!seen.has(othIndex) && (arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
            return seen.add(othIndex);
          }
        })) {
          result = false;
          break;
        }
      } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, customizer, bitmask, stack))) {
        result = false;
        break;
      }
    }
    stack['delete'](array);
    stack['delete'](other);
    return result;
  }

  /**
   * A specialized version of `baseIsEqualDeep` for comparing objects of
   * the same `toStringTag`.
   *
   * **Note:** This function only supports comparing values with tags of
   * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {string} tag The `toStringTag` of the objects to compare.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Function} customizer The function to customize comparisons.
   * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
   *  for more details.
   * @param {Object} stack Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
  function equalByTag(object, other, tag, equalFunc, customizer, bitmask, stack) {
    switch (tag) {
      case dataViewTag:
        if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
          return false;
        }
        object = object.buffer;
        other = other.buffer;
      case arrayBufferTag:
        if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
          return false;
        }
        return true;
      case boolTag:
      case dateTag:
      case numberTag:
        // Coerce booleans to `1` or `0` and dates to milliseconds.
        // Invalid dates are coerced to `NaN`.
        return eq(+object, +other);
      case errorTag:
        return object.name == other.name && object.message == other.message;
      case regexpTag:
      case stringTag:
        // Coerce regexes to strings and treat strings, primitives and objects,
        // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
        // for more details.
        return object == other + '';
      case mapTag:
        var convert = mapToArray;
      case setTag:
        var isPartial = bitmask & PARTIAL_COMPARE_FLAG;
        convert || (convert = setToArray);
        if (object.size != other.size && !isPartial) {
          return false;
        }
        // Assume cyclic values are equal.
        var stacked = stack.get(object);
        if (stacked) {
          return stacked == other;
        }
        bitmask |= UNORDERED_COMPARE_FLAG;

        // Recursively compare objects (susceptible to call stack limits).
        stack.set(object, other);
        var result = equalArrays(convert(object), convert(other), equalFunc, customizer, bitmask, stack);
        stack['delete'](object);
        return result;
      case symbolTag:
        if (symbolValueOf) {
          return symbolValueOf.call(object) == symbolValueOf.call(other);
        }
    }
    return false;
  }

  /**
   * A specialized version of `baseIsEqualDeep` for objects with support for
   * partial deep comparisons.
   *
   * @private
   * @param {Object} object The object to compare.
   * @param {Object} other The other object to compare.
   * @param {Function} equalFunc The function to determine equivalents of values.
   * @param {Function} customizer The function to customize comparisons.
   * @param {number} bitmask The bitmask of comparison flags. See `baseIsEqual`
   *  for more details.
   * @param {Object} stack Tracks traversed `object` and `other` objects.
   * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
   */
  function equalObjects(object, other, equalFunc, customizer, bitmask, stack) {
    var isPartial = bitmask & PARTIAL_COMPARE_FLAG,
      objProps = keys(object),
      objLength = objProps.length,
      othProps = keys(other),
      othLength = othProps.length;
    if (objLength != othLength && !isPartial) {
      return false;
    }
    var index = objLength;
    while (index--) {
      var key = objProps[index];
      if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
        return false;
      }
    }
    // Assume cyclic values are equal.
    var stacked = stack.get(object);
    if (stacked && stack.get(other)) {
      return stacked == other;
    }
    var result = true;
    stack.set(object, other);
    stack.set(other, object);
    var skipCtor = isPartial;
    while (++index < objLength) {
      key = objProps[index];
      var objValue = object[key],
        othValue = other[key];
      if (customizer) {
        var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
      }
      // Recursively compare objects (susceptible to call stack limits).
      if (!(compared === undefined ? objValue === othValue || equalFunc(objValue, othValue, customizer, bitmask, stack) : compared)) {
        result = false;
        break;
      }
      skipCtor || (skipCtor = key == 'constructor');
    }
    if (result && !skipCtor) {
      var objCtor = object.constructor,
        othCtor = other.constructor;

      // Non `Object` object instances with different constructors are not equal.
      if (objCtor != othCtor && 'constructor' in object && 'constructor' in other && !(typeof objCtor == 'function' && objCtor instanceof objCtor && typeof othCtor == 'function' && othCtor instanceof othCtor)) {
        result = false;
      }
    }
    stack['delete'](object);
    stack['delete'](other);
    return result;
  }

  /**
   * Gets the data for `map`.
   *
   * @private
   * @param {Object} map The map to query.
   * @param {string} key The reference key.
   * @returns {*} Returns the map data.
   */
  function getMapData(map, key) {
    var data = map.__data__;
    return isKeyable(key) ? data[typeof key == 'string' ? 'string' : 'hash'] : data.map;
  }

  /**
   * Gets the property names, values, and compare flags of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Array} Returns the match data of `object`.
   */
  function getMatchData(object) {
    var result = keys(object),
      length = result.length;
    while (length--) {
      var key = result[length],
        value = object[key];
      result[length] = [key, value, isStrictComparable(value)];
    }
    return result;
  }

  /**
   * Gets the native function at `key` of `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {string} key The key of the method to get.
   * @returns {*} Returns the function if it's native, else `undefined`.
   */
  function getNative(object, key) {
    var value = getValue(object, key);
    return baseIsNative(value) ? value : undefined;
  }

  /**
   * Gets the `toStringTag` of `value`.
   *
   * @private
   * @param {*} value The value to query.
   * @returns {string} Returns the `toStringTag`.
   */
  var getTag = baseGetTag;

  // Fallback for data views, maps, sets, and weak maps in IE 11,
  // for data views in Edge < 14, and promises in Node.js.
  if (DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag || Map && getTag(new Map()) != mapTag || Promise && getTag(Promise.resolve()) != promiseTag || Set && getTag(new Set()) != setTag || WeakMap && getTag(new WeakMap()) != weakMapTag) {
    getTag = function (value) {
      var result = objectToString.call(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : undefined;
      if (ctorString) {
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag;
          case mapCtorString:
            return mapTag;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag;
          case weakMapCtorString:
            return weakMapTag;
        }
      }
      return result;
    };
  }

  /**
   * Checks if `path` exists on `object`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array|string} path The path to check.
   * @param {Function} hasFunc The function to check properties.
   * @returns {boolean} Returns `true` if `path` exists, else `false`.
   */
  function hasPath(object, path, hasFunc) {
    path = isKey(path, object) ? [path] : castPath(path);
    var result,
      index = -1,
      length = path.length;
    while (++index < length) {
      var key = toKey(path[index]);
      if (!(result = object != null && hasFunc(object, key))) {
        break;
      }
      object = object[key];
    }
    if (result) {
      return result;
    }
    var length = object ? object.length : 0;
    return !!length && isLength(length) && isIndex(key, length) && (isArray(object) || isArguments(object));
  }

  /**
   * Checks if `value` is a valid array-like index.
   *
   * @private
   * @param {*} value The value to check.
   * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
   * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
   */
  function isIndex(value, length) {
    length = length == null ? MAX_SAFE_INTEGER : length;
    return !!length && (typeof value == 'number' || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
  }

  /**
   * Checks if `value` is a property name and not a property path.
   *
   * @private
   * @param {*} value The value to check.
   * @param {Object} [object] The object to query keys on.
   * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
   */
  function isKey(value, object) {
    if (isArray(value)) {
      return false;
    }
    var type = typeof value;
    if (type == 'number' || type == 'symbol' || type == 'boolean' || value == null || isSymbol(value)) {
      return true;
    }
    return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
  }

  /**
   * Checks if `value` is suitable for use as unique object key.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
   */
  function isKeyable(value) {
    var type = typeof value;
    return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
  }

  /**
   * Checks if `func` has its source masked.
   *
   * @private
   * @param {Function} func The function to check.
   * @returns {boolean} Returns `true` if `func` is masked, else `false`.
   */
  function isMasked(func) {
    return !!maskSrcKey && maskSrcKey in func;
  }

  /**
   * Checks if `value` is likely a prototype object.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
   */
  function isPrototype(value) {
    var Ctor = value && value.constructor,
      proto = typeof Ctor == 'function' && Ctor.prototype || objectProto;
    return value === proto;
  }

  /**
   * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` if suitable for strict
   *  equality comparisons, else `false`.
   */
  function isStrictComparable(value) {
    return value === value && !isObject(value);
  }

  /**
   * A specialized version of `matchesProperty` for source values suitable
   * for strict equality comparisons, i.e. `===`.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @param {*} srcValue The value to match.
   * @returns {Function} Returns the new spec function.
   */
  function matchesStrictComparable(key, srcValue) {
    return function (object) {
      if (object == null) {
        return false;
      }
      return object[key] === srcValue && (srcValue !== undefined || key in Object(object));
    };
  }

  /**
   * Converts `string` to a property path array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the property path array.
   */
  var stringToPath = memoize(function (string) {
    string = toString(string);
    var result = [];
    if (reLeadingDot.test(string)) {
      result.push('');
    }
    string.replace(rePropName, function (match, number, quote, string) {
      result.push(quote ? string.replace(reEscapeChar, '$1') : number || match);
    });
    return result;
  });

  /**
   * Converts `value` to a string key if it's not a string or symbol.
   *
   * @private
   * @param {*} value The value to inspect.
   * @returns {string|symbol} Returns the key.
   */
  function toKey(value) {
    if (typeof value == 'string' || isSymbol(value)) {
      return value;
    }
    var result = value + '';
    return result == '0' && 1 / value == -INFINITY ? '-0' : result;
  }

  /**
   * Converts `func` to its source code.
   *
   * @private
   * @param {Function} func The function to process.
   * @returns {string} Returns the source code.
   */
  function toSource(func) {
    if (func != null) {
      try {
        return funcToString.call(func);
      } catch (e) {}
      try {
        return func + '';
      } catch (e) {}
    }
    return '';
  }

  /**
   * Creates an object composed of keys generated from the results of running
   * each element of `collection` thru `iteratee`. The order of grouped values
   * is determined by the order they occur in `collection`. The corresponding
   * value of each key is an array of elements responsible for generating the
   * key. The iteratee is invoked with one argument: (value).
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Collection
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} [iteratee=_.identity]
   *  The iteratee to transform keys.
   * @returns {Object} Returns the composed aggregate object.
   * @example
   *
   * _.groupBy([6.1, 4.2, 6.3], Math.floor);
   * // => { '4': [4.2], '6': [6.1, 6.3] }
   *
   * // The `_.property` iteratee shorthand.
   * _.groupBy(['one', 'two', 'three'], 'length');
   * // => { '3': ['one', 'two'], '5': ['three'] }
   */
  var groupBy = createAggregator(function (result, value, key) {
    if (hasOwnProperty.call(result, key)) {
      result[key].push(value);
    } else {
      result[key] = [value];
    }
  });

  /**
   * Creates a function that memoizes the result of `func`. If `resolver` is
   * provided, it determines the cache key for storing the result based on the
   * arguments provided to the memoized function. By default, the first argument
   * provided to the memoized function is used as the map cache key. The `func`
   * is invoked with the `this` binding of the memoized function.
   *
   * **Note:** The cache is exposed as the `cache` property on the memoized
   * function. Its creation may be customized by replacing the `_.memoize.Cache`
   * constructor with one whose instances implement the
   * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
   * method interface of `delete`, `get`, `has`, and `set`.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Function
   * @param {Function} func The function to have its output memoized.
   * @param {Function} [resolver] The function to resolve the cache key.
   * @returns {Function} Returns the new memoized function.
   * @example
   *
   * var object = { 'a': 1, 'b': 2 };
   * var other = { 'c': 3, 'd': 4 };
   *
   * var values = _.memoize(_.values);
   * values(object);
   * // => [1, 2]
   *
   * values(other);
   * // => [3, 4]
   *
   * object.a = 2;
   * values(object);
   * // => [1, 2]
   *
   * // Modify the result cache.
   * values.cache.set(object, ['a', 'b']);
   * values(object);
   * // => ['a', 'b']
   *
   * // Replace `_.memoize.Cache`.
   * _.memoize.Cache = WeakMap;
   */
  function memoize(func, resolver) {
    if (typeof func != 'function' || resolver && typeof resolver != 'function') {
      throw new TypeError(FUNC_ERROR_TEXT);
    }
    var memoized = function () {
      var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;
      if (cache.has(key)) {
        return cache.get(key);
      }
      var result = func.apply(this, args);
      memoized.cache = cache.set(key, result);
      return result;
    };
    memoized.cache = new (memoize.Cache || MapCache)();
    return memoized;
  }

  // Assign cache to `_.memoize`.
  memoize.Cache = MapCache;

  /**
   * Performs a
   * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
   * comparison between two values to determine if they are equivalent.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to compare.
   * @param {*} other The other value to compare.
   * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
   * @example
   *
   * var object = { 'a': 1 };
   * var other = { 'a': 1 };
   *
   * _.eq(object, object);
   * // => true
   *
   * _.eq(object, other);
   * // => false
   *
   * _.eq('a', 'a');
   * // => true
   *
   * _.eq('a', Object('a'));
   * // => false
   *
   * _.eq(NaN, NaN);
   * // => true
   */
  function eq(value, other) {
    return value === other || value !== value && other !== other;
  }

  /**
   * Checks if `value` is likely an `arguments` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an `arguments` object,
   *  else `false`.
   * @example
   *
   * _.isArguments(function() { return arguments; }());
   * // => true
   *
   * _.isArguments([1, 2, 3]);
   * // => false
   */
  function isArguments(value) {
    // Safari 8.1 makes `arguments.callee` enumerable in strict mode.
    return isArrayLikeObject(value) && hasOwnProperty.call(value, 'callee') && (!propertyIsEnumerable.call(value, 'callee') || objectToString.call(value) == argsTag);
  }

  /**
   * Checks if `value` is classified as an `Array` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array, else `false`.
   * @example
   *
   * _.isArray([1, 2, 3]);
   * // => true
   *
   * _.isArray(document.body.children);
   * // => false
   *
   * _.isArray('abc');
   * // => false
   *
   * _.isArray(_.noop);
   * // => false
   */
  var isArray = Array.isArray;

  /**
   * Checks if `value` is array-like. A value is considered array-like if it's
   * not a function and has a `value.length` that's an integer greater than or
   * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
   * @example
   *
   * _.isArrayLike([1, 2, 3]);
   * // => true
   *
   * _.isArrayLike(document.body.children);
   * // => true
   *
   * _.isArrayLike('abc');
   * // => true
   *
   * _.isArrayLike(_.noop);
   * // => false
   */
  function isArrayLike(value) {
    return value != null && isLength(value.length) && !isFunction(value);
  }

  /**
   * This method is like `_.isArrayLike` except that it also checks if `value`
   * is an object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an array-like object,
   *  else `false`.
   * @example
   *
   * _.isArrayLikeObject([1, 2, 3]);
   * // => true
   *
   * _.isArrayLikeObject(document.body.children);
   * // => true
   *
   * _.isArrayLikeObject('abc');
   * // => false
   *
   * _.isArrayLikeObject(_.noop);
   * // => false
   */
  function isArrayLikeObject(value) {
    return isObjectLike(value) && isArrayLike(value);
  }

  /**
   * Checks if `value` is classified as a `Function` object.
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a function, else `false`.
   * @example
   *
   * _.isFunction(_);
   * // => true
   *
   * _.isFunction(/abc/);
   * // => false
   */
  function isFunction(value) {
    // The use of `Object#toString` avoids issues with the `typeof` operator
    // in Safari 8-9 which returns 'object' for typed array and other constructors.
    var tag = isObject(value) ? objectToString.call(value) : '';
    return tag == funcTag || tag == genTag;
  }

  /**
   * Checks if `value` is a valid array-like length.
   *
   * **Note:** This method is loosely based on
   * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
   * @example
   *
   * _.isLength(3);
   * // => true
   *
   * _.isLength(Number.MIN_VALUE);
   * // => false
   *
   * _.isLength(Infinity);
   * // => false
   *
   * _.isLength('3');
   * // => false
   */
  function isLength(value) {
    return typeof value == 'number' && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
  }

  /**
   * Checks if `value` is the
   * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
   * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
   *
   * @static
   * @memberOf _
   * @since 0.1.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is an object, else `false`.
   * @example
   *
   * _.isObject({});
   * // => true
   *
   * _.isObject([1, 2, 3]);
   * // => true
   *
   * _.isObject(_.noop);
   * // => true
   *
   * _.isObject(null);
   * // => false
   */
  function isObject(value) {
    var type = typeof value;
    return !!value && (type == 'object' || type == 'function');
  }

  /**
   * Checks if `value` is object-like. A value is object-like if it's not `null`
   * and has a `typeof` result of "object".
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
   * @example
   *
   * _.isObjectLike({});
   * // => true
   *
   * _.isObjectLike([1, 2, 3]);
   * // => true
   *
   * _.isObjectLike(_.noop);
   * // => false
   *
   * _.isObjectLike(null);
   * // => false
   */
  function isObjectLike(value) {
    return !!value && typeof value == 'object';
  }

  /**
   * Checks if `value` is classified as a `Symbol` primitive or object.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
   * @example
   *
   * _.isSymbol(Symbol.iterator);
   * // => true
   *
   * _.isSymbol('abc');
   * // => false
   */
  function isSymbol(value) {
    return typeof value == 'symbol' || isObjectLike(value) && objectToString.call(value) == symbolTag;
  }

  /**
   * Checks if `value` is classified as a typed array.
   *
   * @static
   * @memberOf _
   * @since 3.0.0
   * @category Lang
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
   * @example
   *
   * _.isTypedArray(new Uint8Array);
   * // => true
   *
   * _.isTypedArray([]);
   * // => false
   */
  var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

  /**
   * Converts `value` to a string. An empty string is returned for `null`
   * and `undefined` values. The sign of `-0` is preserved.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Lang
   * @param {*} value The value to process.
   * @returns {string} Returns the string.
   * @example
   *
   * _.toString(null);
   * // => ''
   *
   * _.toString(-0);
   * // => '-0'
   *
   * _.toString([1, 2, 3]);
   * // => '1,2,3'
   */
  function toString(value) {
    return value == null ? '' : baseToString(value);
  }

  /**
   * Gets the value at `path` of `object`. If the resolved value is
   * `undefined`, the `defaultValue` is returned in its place.
   *
   * @static
   * @memberOf _
   * @since 3.7.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path of the property to get.
   * @param {*} [defaultValue] The value returned for `undefined` resolved values.
   * @returns {*} Returns the resolved value.
   * @example
   *
   * var object = { 'a': [{ 'b': { 'c': 3 } }] };
   *
   * _.get(object, 'a[0].b.c');
   * // => 3
   *
   * _.get(object, ['a', '0', 'b', 'c']);
   * // => 3
   *
   * _.get(object, 'a.b.c', 'default');
   * // => 'default'
   */
  function get(object, path, defaultValue) {
    var result = object == null ? undefined : baseGet(object, path);
    return result === undefined ? defaultValue : result;
  }

  /**
   * Checks if `path` is a direct or inherited property of `object`.
   *
   * @static
   * @memberOf _
   * @since 4.0.0
   * @category Object
   * @param {Object} object The object to query.
   * @param {Array|string} path The path to check.
   * @returns {boolean} Returns `true` if `path` exists, else `false`.
   * @example
   *
   * var object = _.create({ 'a': _.create({ 'b': 2 }) });
   *
   * _.hasIn(object, 'a');
   * // => true
   *
   * _.hasIn(object, 'a.b');
   * // => true
   *
   * _.hasIn(object, ['a', 'b']);
   * // => true
   *
   * _.hasIn(object, 'b');
   * // => false
   */
  function hasIn(object, path) {
    return object != null && hasPath(object, path, baseHasIn);
  }

  /**
   * Creates an array of the own enumerable property names of `object`.
   *
   * **Note:** Non-object values are coerced to objects. See the
   * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
   * for more details.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Object
   * @param {Object} object The object to query.
   * @returns {Array} Returns the array of property names.
   * @example
   *
   * function Foo() {
   *   this.a = 1;
   *   this.b = 2;
   * }
   *
   * Foo.prototype.c = 3;
   *
   * _.keys(new Foo);
   * // => ['a', 'b'] (iteration order is not guaranteed)
   *
   * _.keys('hi');
   * // => ['0', '1']
   */
  function keys(object) {
    return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
  }

  /**
   * This method returns the first argument it receives.
   *
   * @static
   * @since 0.1.0
   * @memberOf _
   * @category Util
   * @param {*} value Any value.
   * @returns {*} Returns `value`.
   * @example
   *
   * var object = { 'a': 1 };
   *
   * console.log(_.identity(object) === object);
   * // => true
   */
  function identity(value) {
    return value;
  }

  /**
   * Creates a function that returns the value at `path` of a given object.
   *
   * @static
   * @memberOf _
   * @since 2.4.0
   * @category Util
   * @param {Array|string} path The path of the property to get.
   * @returns {Function} Returns the new accessor function.
   * @example
   *
   * var objects = [
   *   { 'a': { 'b': 2 } },
   *   { 'a': { 'b': 1 } }
   * ];
   *
   * _.map(objects, _.property('a.b'));
   * // => [2, 1]
   *
   * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
   * // => [1, 2]
   */
  function property(path) {
    return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
  }
  module.exports = groupBy;
})(lodash_groupby, lodash_groupby.exports);
var groupBy = lodash_groupby.exports;
var styles$d = {
  "label": "List-module__Sq2XuAtm__v0-2-10",
  "labelWrapper": "List-module__3IR2QCJK__v0-2-10",
  "list": "List-module__qyDygjXN__v0-2-10",
  "option": "List-module__Oin-l-U2__v0-2-10",
  "optionIcon": "List-module__BYe-zoha__v0-2-10",
  "optionCheckbox": "List-module__xLBOmJZx__v0-2-10",
  "multiLineOption": "List-module__-FpAR2tw__v0-2-10",
  "selectedText": "List-module__PwwUVsG4__v0-2-10",
  "disabled": "List-module__fIJrgE8p__v0-2-10",
  "multiLineCheckbox": "List-module__eQdOlk-Q__v0-2-10",
  "multiLineIcon": "List-module__kkSi7jPj__v0-2-10",
  "subLabel": "List-module__k62Y8DHk__v0-2-10",
  "listboxOverflowScroll": "List-module__FZuWl4wk__v0-2-10",
  "multiLineList": "List-module__ssC3mUYz__v0-2-10",
  "fullWidth": "List-module__lZpayd1k__v0-2-10",
  "noResults": "List-module__ArAEKcCa__v0-2-10"
};
var styles$c = {
  "labelWrapper": "Option-module__pNvNNRQD__v0-2-10",
  "option": "Option-module__UGrxgEUY__v0-2-10",
  "optionIcon": "Option-module__T9v2Rk9M__v0-2-10",
  "optionCheckbox": "Option-module__-v0oeU1T__v0-2-10",
  "multiLineOption": "Option-module__bWS5CEQu__v0-2-10",
  "selectedText": "Option-module__5e4lde6U__v0-2-10",
  "disabled": "Option-module__BvLqEb0C__v0-2-10",
  "multiLineCheckbox": "Option-module__ZFDxJajp__v0-2-10",
  "multiLineIcon": "Option-module__NvdlbaVg__v0-2-10"
};
var searchSubstring = function (string, substring) {
  return string.toLowerCase().indexOf(substring.toLowerCase());
};
var isScrollableElement = function (el) {
  return el.clientHeight !== el.scrollHeight;
};
var TextWithHighlight = function (_a) {
  var highlightedText = _a.highlightedText,
    text = _a.text,
    _b = _a.selected,
    selected = _b === void 0 ? false : _b,
    _c = _a.disabled,
    disabled = _c === void 0 ? false : _c,
    className = _a.className;
  var startIndex = searchSubstring(text, highlightedText);
  var endIndex = startIndex + highlightedText.length;
  return React__default["default"].createElement(typography.Typography, {
    component: "span",
    token: selected ? 'body-strong-base' : 'body-base',
    color: disabled ? 'text-disabled' : 'text-default',
    className: className
  }, startIndex === -1 ? text : React__default["default"].createElement(React__default["default"].Fragment, null, text.substring(0, startIndex), React__default["default"].createElement(typography.Typography, {
    component: "b",
    token: "body-strong-base"
  }, text.substring(startIndex, endIndex)), text.substring(endIndex)));
};
function SingleLineOptionLabel(_a) {
  var option = _a.option,
    highlightedText = _a.highlightedText,
    selected = _a.selected,
    disabled = _a.disabled;
  return React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  });
}
var styles$b = {
  "label": "MultiLineOptionLabel-module__srEu-lvR__v0-2-10",
  "subLabel": "MultiLineOptionLabel-module__w4-AvNPd__v0-2-10",
  "disabled": "MultiLineOptionLabel-module__Sm-cYmIh__v0-2-10"
};
function MultiLineOptionLabel(_a) {
  var _b;
  var option = _a.option,
    highlightedText = _a.highlightedText,
    selected = _a.selected,
    disabled = _a.disabled,
    isSubLabelSearchEnabled = _a.isSubLabelSearchEnabled;
  return React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement("span", {
    className: styles$b.label
  }, React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  })), React__default["default"].createElement(TextWithHighlight, {
    highlightedText: isSubLabelSearchEnabled ? highlightedText : '',
    text: option.subLabel || '',
    selected: selected,
    disabled: disabled,
    className: classnames__default["default"](styles$b.subLabel, (_b = {}, _b[styles$b.disabled] = option.disabled, _b))
  }));
}
var styles$a = {
  "colorIcon": "ColoredOptionLabel-module__amn-osD1__v0-2-10",
  "coloredOption": "ColoredOptionLabel-module__9-U9rn4j__v0-2-10"
};
function ColoredOptionLabel(_a) {
  var _b;
  var option = _a.option,
    highlightedText = _a.highlightedText,
    selected = _a.selected,
    disabled = _a.disabled;
  var classNames = classnames__default["default"](styles$a.colorIcon, (_b = {}, _b[styles$a.coloredOption] = !option.disabled, _b));
  var appliedStyles = !option.disabled ? {
    '--colored-option': "" + option.color
  } : undefined;
  return React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement("span", {
    className: classNames,
    style: appliedStyles
  }, React__default["default"].createElement(icon.Icon, {
    name: "circle",
    type: "solid",
    size: 12
  })), React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  }));
}
var styles$9 = {
  "label": "AvatarOptionLabel-module__qPE2IjzD__v0-2-10",
  "subLabel": "AvatarOptionLabel-module__kocoE-4a__v0-2-10",
  "wrapper": "AvatarOptionLabel-module__py9cdnNj__v0-2-10",
  "avatar": "AvatarOptionLabel-module__Wq183f0E__v0-2-10",
  "disabledAvatar": "AvatarOptionLabel-module__E8lHTEo4__v0-2-10",
  "labelsWrapper": "AvatarOptionLabel-module__YS1r9R33__v0-2-10",
  "disabled": "AvatarOptionLabel-module__gMnsx4rK__v0-2-10"
};
function AvatarOptionLabel(_a) {
  var _b, _c;
  var option = _a.option,
    highlightedText = _a.highlightedText,
    selected = _a.selected,
    disabled = _a.disabled;
  return React__default["default"].createElement("div", {
    className: styles$9.wrapper
  }, React__default["default"].createElement(avatar.Avatar, {
    src: option.avatar,
    name: option.label,
    containerClassname: classnames__default["default"](styles$9.avatar, (_b = {}, _b[styles$9.disabledAvatar] = option.disabled, _b)),
    imageLoading: option === null || option === void 0 ? void 0 : option.imageLoading
  }), React__default["default"].createElement("div", {
    className: styles$9.labelsWrapper
  }, React__default["default"].createElement("span", {
    className: styles$9.label
  }, React__default["default"].createElement(TextWithHighlight, {
    highlightedText: highlightedText,
    text: option.label,
    selected: selected,
    disabled: disabled
  })), React__default["default"].createElement(typography.Typography, {
    className: classnames__default["default"](styles$9.subLabel, (_c = {}, _c[styles$9.disabled] = option.disabled, _c)),
    component: "span",
    token: "body-base",
    title: option.subLabel
  }, option.subLabel)));
}
var optionLabelComponents = {
  'single-line': SingleLineOptionLabel,
  'multi-line': MultiLineOptionLabel,
  colored: ColoredOptionLabel,
  avatar: AvatarOptionLabel
};
function Option(_a) {
  var _b, _c, _d;
  var disabled = _a.disabled,
    highlightedText = _a.highlightedText,
    onSelect = _a.onSelect,
    onEscape = _a.onEscape,
    option = _a.option,
    optionStyle = _a.optionStyle,
    optionType = _a.optionType,
    selected = _a.selected,
    className = _a.className,
    _e = _a.isSubLabelSearchEnabled,
    isSubLabelSearchEnabled = _e === void 0 ? false : _e;
  var handleKeyDown = function (e) {
    if ([' ', 'Enter'].some(function (k) {
      return k === e.key;
    })) {
      e.preventDefault();
      onSelect(e);
    } else if (e.key === 'Escape') {
      onEscape();
    }
  };
  return React__default["default"].createElement("li", __assign({
    "aria-selected": selected,
    className: classnames__default["default"](styles$c.option, className, (_b = {}, _b[styles$c.selectedText] = selected && optionStyle === 'checkmark', _b[styles$c.multiLineOption] = optionType === 'multi-line', _b[styles$c.disabled] = disabled, _b)),
    onClick: !disabled ? onSelect : utilsCommons.noop,
    onKeyDown: !disabled ? handleKeyDown : utilsCommons.noop,
    role: "option",
    title: option.label,
    tabIndex: 0
  }, utilsCommons.parseMetadata(option.metadata)), optionStyle === 'checkbox' ? React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(checkbox.Checkbox, {
    className: classnames__default["default"](styles$c.optionCheckbox, (_c = {}, _c[styles$c.multiLineCheckbox] = optionType === 'multi-line', _c)),
    checked: selected,
    readOnly: true,
    disabled: disabled,
    tabIndex: -1
  }), React__default["default"].createElement("div", {
    className: styles$c.labelWrapper
  }, React__default["default"].createElement(optionLabelComponents[optionType], {
    option: option,
    highlightedText: highlightedText,
    selected: false,
    disabled: disabled,
    isSubLabelSearchEnabled: isSubLabelSearchEnabled
  }))) : React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(icon.Icon, {
    className: classnames__default["default"](styles$c.optionIcon, (_d = {}, _d[styles$c.multiLineIcon] = optionType === 'multi-line', _d)),
    name: "check",
    size: 14,
    type: "solid"
  }), React__default["default"].createElement("div", {
    className: styles$c.labelWrapper
  }, React__default["default"].createElement(optionLabelComponents[optionType], {
    option: option,
    highlightedText: highlightedText,
    selected: selected,
    disabled: disabled,
    isSubLabelSearchEnabled: isSubLabelSearchEnabled
  }))));
}
var styles$8 = {
  "optionGroup": "OptionGroup-module__sUlg29oI__v0-2-10",
  "optionGroupName": "OptionGroup-module__TsaOfKNJ__v0-2-10"
};
function OptionGroup(_a) {
  var name = _a.name,
    children = _a.children;
  return React__default["default"].createElement("li", {
    className: styles$8.optionGroup
  }, React__default["default"].createElement(typography.Typography, {
    className: styles$8.optionGroupName,
    token: "heading-small",
    component: "div"
  }, name), React__default["default"].createElement("ul", null, children));
}
var styles$7 = {
  "heading-xsmall": "SearchInput-module__-EaqfsiU__v0-2-10",
  "heading-small": "SearchInput-module__ePqEacN0__v0-2-10",
  "heading-medium": "SearchInput-module__IAVTG3mo__v0-2-10",
  "heading-large": "SearchInput-module__y7jNZ-3z__v0-2-10",
  "heading-xlarge": "SearchInput-module__bzC6Ay3D__v0-2-10",
  "heading-2xl": "SearchInput-module__mMTBqbbU__v0-2-10",
  "body-small": "SearchInput-module__pY58nuu1__v0-2-10",
  "body-base": "SearchInput-module__jAnDRJNq__v0-2-10",
  "wrapper": "SearchInput-module__0J-OvDdH__v0-2-10",
  "body-large": "SearchInput-module__lgxyITeH__v0-2-10",
  "body-strong-small": "SearchInput-module__tKPuXqtL__v0-2-10",
  "body-strong-base": "SearchInput-module__vseSZsB2__v0-2-10",
  "body-strong-large": "SearchInput-module__DkuADxlM__v0-2-10",
  "page-heading": "SearchInput-module__9J-Omsxu__v0-2-10",
  "button": "SearchInput-module__85G6QZbl__v0-2-10",
  "form-label": "SearchInput-module__aZ7IhmlS__v0-2-10",
  "caption": "SearchInput-module__izS51RB-__v0-2-10",
  "text-link-default": "SearchInput-module__VxfBCjoM__v0-2-10",
  "text-link-hover": "SearchInput-module__kZwWn-Tw__v0-2-10",
  "table-data-regular": "SearchInput-module__7yPNsGlF__v0-2-10",
  "table-data-bold": "SearchInput-module__XDWh5qrx__v0-2-10",
  "icon": "SearchInput-module__HziZooX4__v0-2-10"
};
var SearchInputWithRef = function (_a, ref) {
  var _b = _a.placeholder,
    placeholder = _b === void 0 ? '' : _b,
    value = _a.value,
    onTextChange = _a.onTextChange,
    onEscape = _a.onEscape;
  var id = utilsHooks.useId('component-');
  var handleChange = function (event) {
    return onTextChange(event.currentTarget.value);
  };
  var handleKeyDown = function (e) {
    if (e.key === 'Escape') {
      e.preventDefault();
      onEscape();
    }
  };
  return React__default["default"].createElement("div", {
    className: styles$7.wrapper,
    role: "search"
  }, React__default["default"].createElement("label", {
    htmlFor: id
  }, React__default["default"].createElement(icon.Icon, {
    className: styles$7.icon,
    color: "icon-subdued",
    name: "search",
    size: 12
  }), React__default["default"].createElement("input", {
    defaultValue: value,
    id: id,
    onChange: handleChange,
    onKeyDown: handleKeyDown,
    placeholder: placeholder,
    ref: ref,
    type: "search"
  })));
};
SearchInputWithRef.displayName = 'SearchInput';
var SearchInput = React__default["default"].forwardRef(SearchInputWithRef);
var styles$6 = {
  "creatableFooterContainer": "AddOptionsFooter-module__eZ9TjiZ4__v0-2-10",
  "inputWrapper": "AddOptionsFooter-module__I8Vmy-fb__v0-2-10",
  "colorPicker": "AddOptionsFooter-module__ptO-B95s__v0-2-10"
};
var deriveFooterButtonState = function (inputValue, loading) {
  if (inputValue.length === 0) return 'disabled';
  if (loading) return 'loading';
  return 'default';
};
function AddOptionsFooter(_a) {
  var createButtonProps = _a.createButtonProps,
    inputProps = _a.inputProps,
    onCreate = _a.onCreate,
    colorPickerOptions = _a.colorPickerOptions;
  var _b = React.useState(''),
    inputValue = _b[0],
    setInputValue = _b[1];
  var _c = React.useState(colorPickerOptions === null || colorPickerOptions === void 0 ? void 0 : colorPickerOptions.initialColor),
    color = _c[0],
    setColor = _c[1];
  var onAddHandler = function () {
    onCreate(__assign({
      value: inputValue || ''
    }, color ? {
      color: color
    } : {}));
    setInputValue('');
  };
  var onInputChange = function (event) {
    setInputValue(event.target.value);
  };
  return React__default["default"].createElement("footer", {
    className: styles$6.creatableFooterContainer
  }, React__default["default"].createElement(input.TextInput, {
    placeholder: inputProps === null || inputProps === void 0 ? void 0 : inputProps.placeholder,
    className: styles$6.inputWrapper,
    onKeyPress: function (e) {
      if (e.key.toLowerCase() === 'enter' && inputValue) onAddHandler();
    },
    metadata: inputProps === null || inputProps === void 0 ? void 0 : inputProps.metadata,
    onChange: onInputChange,
    value: inputValue
  }), colorPickerOptions && React__default["default"].createElement("div", {
    className: styles$6.colorPicker
  }, React__default["default"].createElement(colorPicker.ColorPicker, {
    closeOnSelect: true,
    initialColor: color,
    metadata: colorPickerOptions.metadata,
    onChange: setColor,
    palette: colorPickerOptions.palette,
    title: colorPickerOptions.title
  })), React__default["default"].createElement(button.Button, {
    variant: "emphasized",
    onClick: onAddHandler,
    buttonState: deriveFooterButtonState(inputValue, createButtonProps.loading)
  }, createButtonProps.label));
}
var styles$5 = {
  "loadingContainer": "LoadingState-module__aqfzdZyH__v0-2-10"
};
function LoadingState() {
  return React__default["default"].createElement("div", {
    className: styles$5.loadingContainer,
    "aria-label": "loading"
  }, React__default["default"].createElement(icon.Icon, {
    name: "spinner-third",
    size: 16,
    spin: true,
    color: "icon-highlight",
    type: "solid"
  }));
}
var styles$4 = {
  "submitFooterContainer": "SubmitFooter-module__sDqyZ6Eo__v0-2-10",
  "cancelButton": "SubmitFooter-module__vzrCxYq-__v0-2-10"
};
var SubmitFooter = function (_a) {
  var onSubmit = _a.onSubmit,
    onCancel = _a.onCancel,
    _b = _a.submitLabel,
    submitLabel = _b === void 0 ? 'Apply' : _b,
    _c = _a.cancelSubmitLabel,
    cancelSubmitLabel = _c === void 0 ? 'Cancel' : _c;
  return React__default["default"].createElement("footer", {
    className: styles$4.submitFooterContainer
  }, React__default["default"].createElement(typography.Typography, {
    component: "button",
    token: "button",
    className: styles$4.cancelButton,
    onClick: onCancel,
    type: "button"
  }, cancelSubmitLabel), React__default["default"].createElement(button.Button, {
    variant: "emphasized",
    onClick: onSubmit
  }, submitLabel));
};
var styles$3 = {
  "selectAllOption": "SelectAllOption-module__hUO04-8V__v0-2-10"
};
var SelectAllOption = function (_a) {
  var isSelected = _a.isSelected,
    onSelect = _a.onSelect,
    onEscape = _a.onEscape,
    label = _a.label;
  var selectAllOption = React.useMemo(function () {
    return {
      value: Date.now(),
      label: label
    };
  }, [label]);
  return React__default["default"].createElement(Option, {
    highlightedText: "",
    onSelect: function () {
      return onSelect(!isSelected);
    },
    option: selectAllOption,
    optionStyle: "checkbox",
    optionType: "single-line",
    selected: isSelected,
    className: styles$3.selectAllOption,
    onEscape: onEscape
  });
};
var MIN_OPTIONS_TO_DISPLAY_SELECT_ALL = 7.5;
var MIN_GROUPS_TO_DISPLAY_HEADER = 2;
function List(_a, ref) {
  var _b;
  var className = _a.className,
    selectAllLabel = _a.selectAllLabel,
    highlightedText = _a.highlightedText,
    variant = _a.variant,
    multiple = _a.multiple,
    onSelect = _a.onSelect,
    onSelectAll = _a.onSelectAll,
    onSearchChange = _a.onSearchChange,
    options = _a.options,
    optionType = _a.optionType,
    emptyStateLabel = _a.emptyStateLabel,
    renderEmptyState = _a.renderEmptyState,
    searchable = _a.searchable,
    searchInitialValue = _a.searchInitialValue,
    searchAutofocus = _a.searchAutofocus,
    searchPlaceholder = _a.searchPlaceholder,
    searchNoResultsLabel = _a.searchNoResultsLabel,
    minOptionsToDisplaySearch = _a.minOptionsToDisplaySearch,
    selectedOptionsWithValuesOnly = _a.selectedOptionsWithValuesOnly,
    creatableOptions = _a.creatableOptions,
    style = _a.style,
    isLoading = _a.isLoading,
    submitOptions = _a.submitOptions,
    onSubmit = _a.onSubmit,
    onCancel = _a.onCancel,
    metadata = _a.metadata,
    isSubLabelSearchEnabled = _a.isSubLabelSearchEnabled,
    restProps = __rest(_a, ["className", "selectAllLabel", "highlightedText", "variant", "multiple", "onSelect", "onSelectAll", "onSearchChange", "options", "optionType", "emptyStateLabel", "renderEmptyState", "searchable", "searchInitialValue", "searchAutofocus", "searchPlaceholder", "searchNoResultsLabel", "minOptionsToDisplaySearch", "selectedOptionsWithValuesOnly", "creatableOptions", "style", "isLoading", "submitOptions", "onSubmit", "onCancel", "metadata", "isSubLabelSearchEnabled"]);
  var _c = React.useState(searchInitialValue),
    searchInputValue = _c[0],
    setSearchInputValue = _c[1];
  var searchInputRef = React.useRef(null);
  var listBoxRef = React.useRef(null);
  React.useEffect(function () {
    if (!searchAutofocus || !searchInputRef.current) return;
    setTimeout(function () {
      if (searchInputRef.current) searchInputRef.current.focus();
    });
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  var shouldShowSelectAll = multiple && options.length > MIN_OPTIONS_TO_DISPLAY_SELECT_ALL && searchInputValue.length === 0;
  var selectAllIsSelected = options.length === selectedOptionsWithValuesOnly.length;
  var filteredOptions = options.filter(function (option) {
    return searchSubstring(option.label, searchInputValue) !== -1 || isSubLabelSearchEnabled && option.subLabel && searchSubstring(option.subLabel, searchInputValue) !== -1;
  });
  /**
   * Next useEffect fixes the problem with scrollbar on some OS/browser
   * combinations overstepping its boundaries and taking up list width
   * See: https://personio.atlassian.net/browse/DST-3121
   * See: https://personio.atlassian.net/browse/DST-3063
   */
  React.useLayoutEffect(function () {
    var el = listBoxRef.current;
    if (!el) {
      return;
    }
    if (isScrollableElement(el)) {
      el.classList.add(styles$d.listboxOverflowScroll);
    } else {
      el.classList.remove(styles$d.listboxOverflowScroll);
    }
  }, [listBoxRef, filteredOptions]);
  var shouldShowNoResultsLabel = searchInputValue !== '' && filteredOptions.length === 0;
  var shouldShowSearchInput = searchable && options.length >= minOptionsToDisplaySearch;
  var groupedOptions = groupBy(filteredOptions, function (option) {
    return option.group;
  });
  var shouldShowGroups = Object.keys(groupedOptions).length >= MIN_GROUPS_TO_DISPLAY_HEADER;
  var renderOptions = function (optionsList) {
    var optionsRendered = optionsList.map(function (option) {
      return React__default["default"].createElement(Option, {
        disabled: option.disabled,
        highlightedText: searchable ? searchInputValue : highlightedText,
        key: option.value,
        onSelect: function () {
          return onSelect(option);
        },
        option: option,
        optionStyle: multiple ? 'checkbox' : 'checkmark',
        optionType: optionType,
        selected: selectedOptionsWithValuesOnly.includes(option.value),
        onEscape: onCancel,
        isSubLabelSearchEnabled: isSubLabelSearchEnabled
      });
    });
    return React__default["default"].createElement(React__default["default"].Fragment, null, shouldShowSelectAll && !shouldShowGroups && React__default["default"].createElement(SelectAllOption, {
      onSelect: onSelectAll,
      onEscape: onCancel,
      isSelected: selectAllIsSelected,
      label: selectAllLabel
    }), optionsRendered);
  };
  var renderOptionGroups = function () {
    var groupsRendered = lodash_topairs(groupedOptions).map(function (_a) {
      var groupName = _a[0],
        groupOptions = _a[1];
      return React__default["default"].createElement(OptionGroup, {
        key: groupName,
        name: groupName
      }, renderOptions(groupOptions));
    });
    return React__default["default"].createElement(React__default["default"].Fragment, null, shouldShowSelectAll && React__default["default"].createElement(SelectAllOption, {
      onSelect: onSelectAll,
      onEscape: onCancel,
      isSelected: selectAllIsSelected,
      label: selectAllLabel
    }), groupsRendered);
  };
  var handleSearchInputChange = function (search) {
    setSearchInputValue(search);
    onSearchChange(search);
  };
  return React__default["default"].createElement("div", __assign({
    ref: ref,
    className: classnames__default["default"](styles$d.list, className, (_b = {}, _b[styles$d.multiLineList] = optionType === 'multi-line', _b[styles$d.fullWidth] = variant === 'full-width', _b)),
    style: style
  }, utilsCommons.parseMetadata(utilsCommons.suffixMetadata(metadata, 'list')), restProps), isLoading ? React__default["default"].createElement(LoadingState, null) : React__default["default"].createElement(React__default["default"].Fragment, null, shouldShowSearchInput && React__default["default"].createElement(SearchInput, {
    ref: searchInputRef,
    placeholder: searchPlaceholder,
    value: searchInputValue,
    onTextChange: handleSearchInputChange,
    onEscape: onCancel
  }), shouldShowNoResultsLabel && React__default["default"].createElement(typography.Typography, {
    component: "div",
    token: "body-base",
    className: styles$d.noResults
  }, searchNoResultsLabel + " \"" + searchInputValue + "\""), !shouldShowNoResultsLabel && (options.length === 0 ? renderEmptyState({
    label: emptyStateLabel
  }) : React__default["default"].createElement("ul", {
    role: "listbox",
    ref: listBoxRef
  }, shouldShowGroups ? renderOptionGroups() : renderOptions(filteredOptions))), creatableOptions && React__default["default"].createElement(AddOptionsFooter, {
    onCreate: creatableOptions.onCreate,
    createButtonProps: creatableOptions.createButtonProps,
    inputProps: creatableOptions.inputProps,
    colorPickerOptions: creatableOptions.colorPickerOptions
  }), !creatableOptions && submitOptions && React__default["default"].createElement(SubmitFooter, {
    onSubmit: onSubmit,
    onCancel: onCancel,
    submitLabel: submitOptions.submitLabel,
    cancelSubmitLabel: submitOptions.cancelLabel
  })));
}
var ListWithRef = React.forwardRef(List);
var styles$2 = {
  "defaultEmptyState": "DefaultEmptyState-module__FTFxVEgG__v0-2-10"
};
function DefaultEmptyState(_a) {
  var label = _a.label;
  return React__default["default"].createElement(typography.Typography, {
    className: styles$2.defaultEmptyState,
    token: "body-base",
    component: "div"
  }, label);
}
var styles$1 = {
  "selectTrigger": "DefaultTrigger-module__xHrx-ta1__v0-2-10",
  "fullWidth": "DefaultTrigger-module__WSZDZ8HZ__v0-2-10",
  "innerText": "DefaultTrigger-module__mSFfFKmq__v0-2-10",
  "outline-warning": "DefaultTrigger-module__RYg-PVpV__v0-2-10",
  "outline-error": "DefaultTrigger-module__o2K-kq-I__v0-2-10",
  "disabled": "DefaultTrigger-module__pAwjr6oM__v0-2-10",
  "selectTriggerIcons": "DefaultTrigger-module__QGiFmuKX__v0-2-10",
  "icon": "DefaultTrigger-module__giOpLvI6__v0-2-10"
};
var styles = {
  "selectClearButton": "SelectClearButton-module__Gd9SE3Tc__v0-2-10"
};
var SelectClearButton = function (_a) {
  var onClick = _a.onClick,
    disabled = _a.disabled,
    _b = _a.ariaLabelClearButton,
    ariaLabelClearButton = _b === void 0 ? 'Clear Select Input' : _b;
  return React__default["default"].createElement("div", {
    role: "button",
    className: styles.selectClearButton,
    onClick: disabled ? utilsCommons.noop : onClick,
    onKeyPress: disabled ? utilsCommons.noop : onClick,
    tabIndex: -1,
    "aria-label": ariaLabelClearButton
  }, React__default["default"].createElement(icon.Icon, {
    name: "times-circle",
    type: "solid",
    color: "icon-subdued"
  }));
};
var DefaultTrigger = React__default["default"].forwardRef(function (_a, ref) {
  var _b;
  var disabled = _a.disabled,
    variant = _a.variant,
    label = _a.label,
    multiple = _a.multiple,
    onClick = _a.onClick,
    selectedOptions = _a.selectedOptions,
    visible = _a.visible,
    _c = _a.outline,
    outline = _c === void 0 ? 'default' : _c,
    _d = _a.autoFocus,
    autoFocus = _d === void 0 ? false : _d,
    triggerId = _a.triggerId,
    onClear = _a.onClear;
  var hasSelectedOption = selectedOptions.length > 0;
  var renderSingleSelectionLabel = function () {
    var firstItem = selectedOptions[0];
    return hasSelectedOption ? firstItem.label : label;
  };
  var renderMultiSelectionLabel = function () {
    return hasSelectedOption ? label + " \u00B7 " + selectedOptions.length : label;
  };
  var isFullWidth = variant === 'full-width';
  return React__default["default"].createElement(typography.Typography, __assign({
    ref: ref,
    component: "button",
    token: hasSelectedOption ? 'body-strong-base' : 'body-base',
    className: classnames__default["default"](styles$1.selectTrigger, styles$1["outline-" + outline], (_b = {}, _b[styles$1.fullWidth] = isFullWidth, _b[styles$1.disabled] = disabled, _b)),
    type: "button",
    disabled: disabled,
    onClick: onClick,
    // eslint-disable-next-line jsx-a11y/no-autofocus
    autoFocus: autoFocus
  }, triggerId ? {
    id: triggerId
  } : {}), React__default["default"].createElement("span", {
    className: styles$1.innerText
  }, multiple ? renderMultiSelectionLabel() : renderSingleSelectionLabel()), React__default["default"].createElement("div", {
    className: styles$1.selectTriggerIcons
  }, onClear && selectedOptions.length > 0 ? React__default["default"].createElement(SelectClearButton, {
    onClick: onClear,
    disabled: disabled
  }) : null, React__default["default"].createElement("div", {
    className: styles$1.icon
  }, React__default["default"].createElement(icon.Icon, {
    name: visible ? 'angle-up' : 'angle-down',
    type: "solid",
    color: "icon-default"
  }))));
});
var useListVisibilityChangeHandler = function (onListVisibilityChange, visible) {
  var initialRender = React.useRef(true);
  React.useEffect(function () {
    if (initialRender.current) {
      initialRender.current = false;
    } else {
      onListVisibilityChange(visible);
    }
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [visible]);
};
function SelectWithRef(_a, ref) {
  var className = _a.className,
    listClassName = _a.listClassName,
    _b = _a.closeOnSelect,
    closeOnSelect = _b === void 0 ? false : _b,
    _c = _a.disabled,
    disabled = _c === void 0 ? false : _c,
    _d = _a.variant,
    variant = _d === void 0 ? 'inline' : _d,
    _e = _a.selectAllLabel,
    selectAllLabel = _e === void 0 ? 'Select all' : _e,
    metadata = _a.metadata,
    _f = _a.multiple,
    multiple = _f === void 0 ? false : _f,
    _g = _a.onSearchChange,
    onSearchChange = _g === void 0 ? utilsCommons.noop : _g,
    _h = _a.onSelect,
    onSelect = _h === void 0 ? utilsCommons.noop : _h,
    _j = _a.onListVisibilityChange,
    onListVisibilityChange = _j === void 0 ? utilsCommons.noop : _j,
    options = _a.options,
    _k = _a.emptyStateLabel,
    emptyStateLabel = _k === void 0 ? 'Nothing to display' : _k,
    _l = _a.renderEmptyState,
    renderEmptyState = _l === void 0 ? DefaultEmptyState : _l,
    _m = _a.renderTrigger,
    renderTrigger = _m === void 0 ? function (props) {
      return React__default["default"].createElement(DefaultTrigger, __assign({}, props));
    } : _m,
    _o = _a.optionType,
    optionType = _o === void 0 ? 'single-line' : _o,
    _p = _a.searchable,
    searchable = _p === void 0 ? true : _p,
    _q = _a.searchAutofocus,
    searchAutofocus = _q === void 0 ? true : _q,
    _r = _a.searchInitialValue,
    searchInitialValue = _r === void 0 ? '' : _r,
    _s = _a.searchNoResultsLabel,
    searchNoResultsLabel = _s === void 0 ? 'No results for' : _s,
    _t = _a.searchPlaceholder,
    searchPlaceholder = _t === void 0 ? 'Search' : _t,
    _u = _a.selectedOptions,
    selectedOptions = _u === void 0 ? [] : _u,
    _v = _a.minOptionsToDisplaySearch,
    minOptionsToDisplaySearch = _v === void 0 ? 8 : _v,
    _w = _a.triggerLabel,
    triggerLabel = _w === void 0 ? '' : _w,
    _x = _a.outline,
    outline = _x === void 0 ? 'default' : _x,
    _y = _a.autoFocus,
    autoFocus = _y === void 0 ? false : _y,
    triggerId = _a.triggerId,
    creatableOptions = _a.creatableOptions,
    _z = _a.isClearable,
    isClearable = _z === void 0 ? false : _z,
    _0 = _a.highlightedText,
    highlightedText = _0 === void 0 ? '' : _0,
    _1 = _a.isLoading,
    isLoading = _1 === void 0 ? false : _1,
    submitOptions = _a.submitOptions,
    _2 = _a.isSubLabelSearchEnabled,
    isSubLabelSearchEnabled = _2 === void 0 ? false : _2;
  var _3 = React.useState(false),
    visible = _3[0],
    setVisibility = _3[1];
  var _4 = utilsHooks.useAutoPosition(),
    floatTriggerRef = _4.triggerRef,
    floatRef = _4.floatRef,
    floatStyles = _4.styles;
  var selectTriggerRef = React.useRef(null);
  var onClickOutsideRef = utilsHooks.useClickOutside(function () {
    return visible && setVisibility(false);
  });
  useListVisibilityChangeHandler(onListVisibilityChange, visible);
  var selectedOptionsWithValuesOnly = React.useMemo(function () {
    return selectedOptions.map(function (selectedOption) {
      return selectedOption.value;
    });
  }, [selectedOptions]);
  var beforeSelect = function (callback) {
    return function () {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      }
      if (closeOnSelect) setVisibility(false);
      callback.apply(void 0, args);
    };
  };
  var handleClear = function (evt) {
    evt.stopPropagation();
    var fixedOptions = getFixedOptions(options, selectedOptions);
    onSelect(fixedOptions);
    if (submitOptions) {
      submitOptions.onSubmit(fixedOptions);
    }
    setVisibility(false);
  };
  var handleSelectAll = function (selected) {
    var opts = selected ? getAllSelectableOptions(options, selectedOptions) : getFixedOptions(options, selectedOptions);
    onSelect(opts);
  };
  var handleSelect = function (option) {
    onSelect(getSelectedValues({
      option: option,
      selectedOptions: selectedOptions,
      selectedOptionsWithValuesOnly: selectedOptionsWithValuesOnly,
      multiple: multiple
    }));
  };
  var handleTriggerClick = function () {
    setVisibility(function (currentVisibility) {
      return !currentVisibility;
    });
    if (visible && submitOptions) {
      submitOptions.onCancel();
    }
  };
  var finalRef = utilsHooks.useForkRef([ref, selectTriggerRef, onClickOutsideRef]);
  var _5 = React.useState(),
    triggerWidth = _5[0],
    setTriggerWidth = _5[1];
  var triggerRef = utilsHooks.useForkRef([floatTriggerRef, function (elem) {
    if (elem) setTriggerWidth(getComputedStyle(elem).width);
  }]);
  var handleSubmit = function () {
    if (submitOptions) submitOptions.onSubmit(selectedOptions);
    setVisibility(false);
  };
  var handleCancelSubmit = function () {
    setVisibility(false);
    if (submitOptions) submitOptions.onCancel();
  };
  return React__default["default"].createElement("div", __assign({
    className: className,
    ref: finalRef
  }, utilsCommons.parseMetadata(metadata)), React__default["default"].createElement("div", null, renderTrigger({
    selectRef: selectTriggerRef,
    ref: triggerRef,
    disabled: disabled,
    variant: variant,
    label: triggerLabel,
    multiple: multiple,
    onClick: handleTriggerClick,
    selectedOptions: selectedOptions,
    visible: visible,
    outline: outline,
    autoFocus: autoFocus,
    triggerId: triggerId,
    setListVisibility: setVisibility,
    onClear: isClearable ? handleClear : undefined
  })), visible && React__default["default"].createElement(ListWithRef, {
    className: listClassName,
    metadata: metadata,
    selectAllLabel: selectAllLabel,
    isLoading: isLoading,
    highlightedText: highlightedText,
    variant: variant,
    multiple: multiple,
    onSelect: beforeSelect(handleSelect),
    onSelectAll: beforeSelect(handleSelectAll),
    onSearchChange: onSearchChange,
    options: options,
    optionType: optionType,
    emptyStateLabel: emptyStateLabel,
    renderEmptyState: renderEmptyState,
    selectedOptionsWithValuesOnly: selectedOptionsWithValuesOnly,
    searchable: searchable,
    searchNoResultsLabel: searchNoResultsLabel,
    searchPlaceholder: searchPlaceholder,
    searchInitialValue: searchInitialValue,
    searchAutofocus: searchAutofocus,
    minOptionsToDisplaySearch: minOptionsToDisplaySearch,
    onSubmit: handleSubmit,
    onCancel: handleCancelSubmit,
    submitOptions: submitOptions,
    isSubLabelSearchEnabled: isSubLabelSearchEnabled,
    creatableOptions: creatableOptions ? __assign(__assign({}, creatableOptions), {
      onCreate: function (createdItem) {
        if (closeOnSelect && !multiple) setVisibility(false);
        creatableOptions.onCreate(createdItem);
      }
    }) : creatableOptions,
    ref: floatRef,
    style: __assign(__assign(__assign({}, floatStyles), variant === 'full-width' ? {
      width: triggerWidth
    } : {}), isLoading ? {
      minWidth: triggerWidth
    } : {})
  }));
}
SelectWithRef.displayName = 'SearchableSubLabelSelect';
/**
 * According to this article: https://fettblog.eu/typescript-react-generic-forward-refs/
 */
var SearchableSubLabelSelect = React__default["default"].forwardRef(SelectWithRef);
exports.DefaultEmptyState = DefaultEmptyState;
exports.SearchableSubLabelSelect = SearchableSubLabelSelect;
//# sourceMappingURL=index.js.map
