import { SelectOption } from './types';
declare type GetSelectedValueParams<T extends SelectOption> = {
    multiple: boolean;
    option: T;
    selectedOptions: T[];
    selectedOptionsWithValuesOnly: Array<string | number>;
};
export declare function getSelectedValues<T extends SelectOption>({ multiple, option, selectedOptions, selectedOptionsWithValuesOnly, }: GetSelectedValueParams<T>): T[];
/**
 * Returns options that are pre-selected and disabled.
 * @param allOptions
 * @param preSelectedOptions
 */
export declare function getFixedOptions<T extends SelectOption>(allOptions: T[], preSelectedOptions: T[]): T[];
/**
 * Returns a list of option that are fixed and are enabled
 * @param options
 * @param preSelectedOptions
 */
export declare function getAllSelectableOptions<T extends SelectOption>(options: T[], preSelectedOptions: T[]): T[];
export {};
